const nsIAzComm = Components.interfaces.nsIAzComm;
const nsISupports = Components.interfaces.nsISupports;
const CLASS_ID = Components.ID("{a4d68360-7f4e-11db-9fe1-0800200c9a66}");
const CLASS_NAME = "AzComm Component";
const CONTRACT_ID = "@foxtorrent.mozdev.org/azcomm;1";

function AzComm(){
};

AzComm.prototype = {
	/*
	 * Base64 encoder from www.webtoolkit.info
	 */
	Base64: {
	 
	     // private property
	     _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
	 
	     // public method for encoding
	     encode : function (input) {
		 var output = "";
		 var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		 var i = 0;
	 
		 input = this._utf8_encode(input);
	 
		 while (i < input.length) {
	 
		     chr1 = input.charCodeAt(i++);
		     chr2 = input.charCodeAt(i++);
		     chr3 = input.charCodeAt(i++);
	 
		     enc1 = chr1 >> 2;
		     enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
		     enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
		     enc4 = chr3 & 63;
	 
		     if (isNaN(chr2)) {
			 enc3 = enc4 = 64;
		     } else if (isNaN(chr3)) {
			 enc4 = 64;
		     }
	 
		     output = output +
		     this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
		     this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
	 
		 }
	 
		 return output;
	     },
	 
	     // public method for decoding
	     decode : function (input) {
		 var output = "";
		 var chr1, chr2, chr3;
		 var enc1, enc2, enc3, enc4;
		 var i = 0;
	 
		 input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	 
		 while (i < input.length) {
	 
		     enc1 = this._keyStr.indexOf(input.charAt(i++));
		     enc2 = this._keyStr.indexOf(input.charAt(i++));
		     enc3 = this._keyStr.indexOf(input.charAt(i++));
		     enc4 = this._keyStr.indexOf(input.charAt(i++));
	 
		     chr1 = (enc1 << 2) | (enc2 >> 4);
		     chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
		     chr3 = ((enc3 & 3) << 6) | enc4;
	 
		     output = output + String.fromCharCode(chr1);
	 
		     if (enc3 != 64) {
			 output = output + String.fromCharCode(chr2);
		     }
		     if (enc4 != 64) {
			 output = output + String.fromCharCode(chr3);
		     }
	 
		 }
	 
		 output = this._utf8_decode(output);
	 
		 return output;
	 
	     },
	 
	     // private method for UTF-8 encoding
	     _utf8_encode : function (string) {
		 string = string.replace(/\r\n/g,"\n");
		 var utftext = "";
	 
		 for (var n = 0; n < string.length; n++) {
	 
		     var c = string.charCodeAt(n);
	 
		     if (c < 128) {
			 utftext += String.fromCharCode(c);
		     }
		     else if((c > 127) && (c < 2048)) {
			 utftext += String.fromCharCode((c >> 6) | 192);
			 utftext += String.fromCharCode((c & 63) | 128);
		     }
		     else {
			 utftext += String.fromCharCode((c >> 12) | 224);
			 utftext += String.fromCharCode(((c >> 6) & 63) | 128);
			 utftext += String.fromCharCode((c & 63) | 128);
		     }
	 
		 }
	 
		 return utftext;
	     },
	 
	     // private method for UTF-8 decoding
	     _utf8_decode : function (utftext) {
		 var string = "";
		 var i = 0;
		 var c = c1 = c2 = 0;
	 
		 while ( i < utftext.length ) {
	 
		     c = utftext.charCodeAt(i);
	 
		     if (c < 128) {
			 string += String.fromCharCode(c);
			 i++;
		     }
		     else if((c > 191) && (c < 224)) {
			 c2 = utftext.charCodeAt(i+1);
			 string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
			 i += 2;
		     }
		     else {
			 c2 = utftext.charCodeAt(i+1);
			 c3 = utftext.charCodeAt(i+2);
			 string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
			 i += 3;
		     }
	 
		 }
	 
		 return string;
	     }
	 
	 },
	mAuthenticate: false,
	mConnected: false,
	mConnectionID: "",
	mPluginID: "",
	mDownloadManagerID: "",
	mTorrentManagerID: "",
	mRequestID: 0,
	mHost: "",
	mPort: 0,
	mUser: "",
	mPass: "",
	mDownloads: null,
	mArgs: null,
	get connectionID() {return this.mConnectionID;},
	set connectionID(aConnectionID) {return this.mConnectionID = aConnectionID;},
	get pluginID() {return this.mPluginID;},
	set pluginID(aPluginID) {return this.mPluginID = aPluginID;},
	get downloadManagerID() {return this.mDownloadManagerID;},
	set downloadManagerID(aDownloadManagerID) {return this.mDownloadManagerID = aDownloadManagerID;},
	get torrentManagerID() {return this.mTorrentManagerID;},
	set torrentManagerID(aTorrentManagerID) {return this.mTorrentManagerID = aTorrentManagerID;},
	get requestID() {return this.mRequestID;},
	set requestID(aRequestID) {return this.mRequestID = aRequestID;},
	get host() {return this.mHost;},
	set host(aHost) {return this.mHost = aHost;},
	get port() {return this.mPort;},
	set port(aPort) {return this.mPort = aPort;},
	get user() {return this.mUser;},
	set user(aUser) {return this.mUser = aUser;},
	get pass() {return this.mPass;},
	set pass(aPass) {return this.mPass = aPass;},
	get downloads() {return this.mDownloads;},
	set downloads(aDownloads) {return this.mDownloads = aDownloads;},
	get connected() {return this.mConnected;},
	get authenticate() {return this.mAuthenticate;},
	set authenticate(aAuthenticate) {return this.mAuthenticate = aAuthenticate;},
	QueryInterface: function(iid) {
		if (!iid.equals(nsIAzComm) && !iid.equals(nsISupports))
			throw Components.results.NS_ERROR_NO_INTERFACE;
		return this;
	},
	init: function() {
		this.mConnected = false;
		this.mRequestID = 0;
		this.call("getSingleton",null);
	},
	restart: function(id) {
		this.call("restart", id);
	},
	forceStart: function(id) {
		this.call("setForceStart", id);
	},
	moveUp: function(id) {
		this.call("moveUp", id);
	},
	moveDown: function(id) {
		this.call("moveDown", id);
	},
	stopTorrent: function(id) {
		this.call("stop", id);
	},
	remove: function(id) {
		this.call("remove", id);
	},
	addURL: function(url) {
		this.mArgs = Array(url);
		this.call("addDownload[URL]", this.mDownloadManagerID);
		this.mArgs = null;
	},
	getDownloads: function() {
		this.mDownloads = null;
		this.call("getDownloads", null);
	},
	getDownloadManager: function() {
		dump("getDownloadManager: " + this.mPluginID + "\n");
		this.call("getDownloadManager", this.mPluginID);
	},
	getTorrentManager: function() {
	},
	sendToSocket: function(output, method) {
		try {
			var transportService = Components.classes["@mozilla.org/network/socket-transport-service;1"].getService(Components.interfaces.nsISocketTransportService);
			var transport = transportService.createTransport(null, 0, this.mHost, this.mPort, null);

			var stream = transport.openInputStream(0,0,0);
			var instream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
			instream.init(stream);

			var outstream = transport.openOutputStream(0,0,0);
			var reqheader = "POST /process.cgi HTTP/1.1\r\nHost: " + this.mHost + ":" + this.mPort + "\r\n";
			if (this.mAuthenticate && this.mUser && this.mUser.length > 0 && this.mPass && this.mPass.length > 0)
				reqheader += "Authorization: Basic " + this.Base64.encode(this.mUser + ":" + this.mPass) + "\r\n";
			reqheader += "Content-Length: " + output.length + "\r\n\r\n"
			outstream.write(reqheader + output, reqheader.length + output.length);

			var dataListener = {
				data : "",
				onStartRequest: function(request, context){},
				onStopRequest: function(request, context, status) {
					instream.close();
					outstream.close();
					dump(this.data);
					if (method == "getSingleton" || method == "getDownloadManager" || method == "getDownloads") {
						var idx = this.data.indexOf("<RESPONSE>");
						if (idx < 0) {
							dump("Server returned invalid response\n");
							return;
						}
						var parser = Components.classes['@mozilla.org/xmlextras/domparser;1'].createInstance(Components.interfaces.nsIDOMParser);
						var doc = parser.parseFromString(this.data.substr(idx), "text/xml");
						var xmlDoc = doc.documentElement;
						if (xmlDoc.childNodes.length == 1)
							xmlDoc = xmlDoc.firstChild;
						if (method == "getSingleton") {
							for (var i = 0; i < xmlDoc.childNodes.length; i++) {
								switch (xmlDoc.childNodes[i].tagName) {
									case "_object_id":
										this.parent.mPluginID = xmlDoc.childNodes[i].firstChild.nodeValue.replace(/^\s+|\s+$/g,"");
										dump("this.mPluginID: " + this.parent.mPluginID + "\n");
										break;
									case "_connection_id":
										this.parent.mConnectionID = xmlDoc.childNodes[i].firstChild.nodeValue.replace(/^\s+|\s+$/g,"");
										dump("this.mConnectionID: " + this.parent.mConnectionID + "\n");
										break;
								}
							}
							this.parent.getDownloadManager();
						} else if (method == "getDownloadManager") {
							for (var i = 0; i < xmlDoc.childNodes.length; i++) {
								switch (xmlDoc.childNodes[i].tagName) {
									case "_object_id":
										this.parent.mDownloadManagerID = xmlDoc.childNodes[i].firstChild.nodeValue.replace(/^\s+|\s+$/g,"");
										this.parent.mConnected = true;
										dump("this.mDownloadManagerID: " + this.parent.mDownloadManagerID + "\n");
										break;
								}
							}
						} else if (method == "getDownloads") {
							this.parent.mDownloads = doc;
						}
					}
				},
				onDataAvailable: function(request, content, inputStream, offset, count) {
					this.data += instream.read(count);
				},
			};
			dataListener.parent = this;
			var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"].createInstance(Components.interfaces.nsIInputStreamPump);
			pump.init(stream, -1, -1, 0, 0, false);
			pump.asyncRead(dataListener, null);
		} catch (ex) {
			dump(ex);
		}
	},
	call: function(method, objid) {
		xml = "";
		if (objid && objid.length > 0 && this.mConnectionID && this.mConnectionID.length > 0)
			xml = "  <OBJECT>\n    <_object_id>" + objid + "</_object_id>\n  </OBJECT>\n  <CONNECTION_ID>" + this.mConnectionID + "</CONNECTION_ID>\n";
		xml = "  <METHOD>" + method + "</METHOD>\n" + xml + "  <REQUEST_ID>" + this.mRequestID + "</REQUEST_ID>\n";
		if (method == "addDownload[URL]" && this.mArgs != null && this.mArgs.length > 0) {
			xml += "  <PARAMS>";
			for (i = 0; i < this.mArgs.length; i++)
				xml += "   <ENTRY>" + this.mArgs[i] + "</ENTRY>\n";
			xml += "</PARAMS>\n";
		}
		xml = "<REQUEST>\n" + xml + "</REQUEST>";
		this.mRequestID++;
		dump(xml + "\n");
		this.sendToSocket(xml, method);
	}
};

var AzCommFactory = {
	createInstance: function(outer, iid) {
		if (outer != null)
			throw Components.results.NS_ERROR_NO_AGGREGATION;
		return (new AzComm()).QueryInterface(iid);
	}
};

var AzCommModule = {
	_firstTime: true,
	registerSelf: function(compMgr, fileSpec, alocation, type) {
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, fileSpec, alocation, type);
	},
	unregisterSelf: function(compMgr, alocation, type) {
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.unregisterFactoryLocation(CLASS_ID, alocation);
	},
	getClassObject: function(compMgr, cid, iid) {
		if (!iid.equals(Components.interfaces.nsIFactory))
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		if (cid.equals(CLASS_ID))
			return AzCommFactory;
		throw Components.results.NS_ERROR_NO_INTERFACE;
	},
	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {return AzCommModule;}
